// JavaScript Document


/*
	Les globals
*/
var glLogin = null;
var glPassword = null;
var glUrl = null;
var glPort = null;

var levels = [new faniTreeView()];


/***
 * return l'index
 */
function searchInItem(type, column, toFind) {
	for (i = 0; i < levels.length; i++) {
		if (levels[i].type == type && levels[i][column] == toFind) {
			return i;
		}
	}
	return null;
}

/***
 * Fonction de gestion de l'evenement onmouvemove.... c vraiment trop bourrin !!!
 * mais ca fonctionne
 */ 
function myMouseMove(tree, event) {
	var str_OrigTarget = event.target;

        //if target is a treechildren, we're right
        if (str_OrigTarget.localName == "treechildren")
        {

                //create storage containers for results values
                var obj_Row     = new Object;
                var obj_Col     = new Object;
                var obj_Child   = new Object;

		var row = tree.treeBoxObject.getRowAt(event.clientX, event.clientY);
		if (row == -1) {
			event.target.removeAttribute("tooltip")
			return;
		}
		event.target.setAttribute("tooltip", "tooltip")
		
		document.getElementById('tooltipLib').value = 'Libelle : ' + tree.view.getCellText(row, "linkLib");
		document.getElementById('tooltipLink').value = 'Lien : ' + tree.view.getCellText(row, "linkLink");
		document.getElementById('tooltipKeywords').value = 'Mots cls : ' + tree.view.getCellText(row, "linkKeywords");
		document.getElementById('tooltipubDate').value = 'Date de Publication : ' + tree.view.getCellText(row, "linkpubDate");
		document.getElementById('tooltipAuthor').value = 'Auteur : ' + tree.view.getCellText(row, "linkAuthor");

	}
		

	return true;
}

/***
 * Cette fonction est appele lors du click sur le boutton connexion/deconnexion
 * elle a pour role de s'authentifier puis de rcuprer les RSS visibles
 */
function changeButton(login, password, url, port)
{
    glLogin = login;
    glPassword = password;
    glUrl = url;
    glPort = port;

	if (getValueOfPref("middlemouse.contentLoadURL") == true) {
		setValueOfPref("middlemouse.contentLoadURL", false);
	}
	authSOAP();
}


/***
 * Fonction gnrique rcuperant des informations sur les onglets(URL/Titre)
 */
function getAllTabInfo(info) {
	var toRet = new Array();
	
	var browser = getBrowser();
	
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var l = browser.mPanelContainer.childNodes.length
	netscape.security.PrivilegeManager.revertPrivilege("UniversalXPConnect");
	
	for(var i = 0; i < l; i++) {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		var b = getTabulation(i,browser);
		try {
			if ("URL" == info) {
				toRet.push(b.currentURI.spec);
			}
			if ("TITLE" == info) {
				toRet.push(b.contentTitle);
			}
			if ("IMAGE" == info) {
				toRet.push(b.mFavIconURL);
			}
		} catch(e) {}
		netscape.security.PrivilegeManager.revertPrivilege("UniversalXPConnect");
	}
	return toRet;
}


function setTabURLInSelect(nameSelect) {
	nameSelect.removeAllItems();
	var allLinks = getAllTabInfo("URL");
	for (i = 0; i < allLinks.length; i++) {
		item = nameSelect.appendItem(allLinks[i]);
	}
	nameSelect.setAttribute("onpopupshowing", "setTabURLInSelect(document.getElementById('liens-text'));");
	return true;
}

function setTabTitleInSelect(nameSelect) {
	/* ca evite le probleme de la prexistance du menu URL lors du choix du titre */
	setTabURLInSelect(document.getElementById('liens-text'));

	nameSelect.removeAllItems();
	var allLinks = getAllTabInfo("TITLE");	

	for (i = 0; i < allLinks.length; i++) {
		item = nameSelect.appendItem(allLinks[i]);
	}
/***
 * quand on efface le contenu de la menulist... on efface la node que l'on as cree a la main
 * et donc on perd l'evenement qui lui correspondait.. par contre la on as deux fois le meme
 * evenement
 */
	nameSelect.setAttribute("onpopupshowing", "setTabTitleInSelect(document.getElementById('libelle-text'));");
	return true;
}

/***
 * Cette fonction existe  cause du bug de firefox qui coupe le input
 * si on vire removeAllItem
 */
function eraseSelectContent(nameSelect) {
	while (nameSelect.childNodes.length != 0) {
		nameSelect.removeChild(nameSelect.childNodes[0]);
	}
}

/*
* Pour desactiver l'item Supprimer du menu
*/
function suppParseResponse(response) {

	if (!response) {
		return;
    }
    	
    var tree = document.getElementById('tree-left');
    var lib = levels[0].getItemAtIndex(tree.currentIndex)._parentItem.linkLib; 
	var num = new Object();
    var params = response.getParameters(false, num);
    var second = params[0].element.getElementsByTagName("item");

	for (i = 0; i < second.length; i++) {
	       //Match la categorie
		if (second[i].textContent.search(lib) != -1)
			//Regarde la valeur de suppr 
			if (second[i].childNodes[7].textContent == "0")
				document.getElementById('clipmenuDel').setAttribute('disabled','true');	
	}
}


/* 
0 - Bouton gauche
1 - Bouton du milieu 
2 - Bouton droit
*/
function affLinksOfRSSFeed(tree,event) { 
	if (event.button == "1") {
	  	var browser = getBrowser();
		if (tree.view.getCellText(tree.currentIndex,"linkLink") != "")
	  		browser.addTab(tree.view.getCellText(tree.currentIndex,"linkLink"));
	 }
	 
	 if (event.button == "2") { 	
   		var params = new Array();
		dofanicall("getBookmarks", params, suppParseResponse, null);
	}
}




/***
 * Cette fonction sert  mettre  jour les index presents dans l'arbre
 * Elle ne met  jour q'un seul index
 */
function delLevelsItem(index) {
	delete levels[index];
	levels.splice(index, 1);
}

/***
 * Cette fonction sert  effacer le contenu d'un RSS
 * @param index : index du RSS dont les enfants doivent etre effacer
 * @param himSelf : le RSS doit -il etre effacer lui aussi
 */
function delLevelsRSS(index, himSelf) {
	var i = 0;
	while (i < levels.length) {
		if (levels[i]._parentItem != null && levels[i]._parentItem.type == "RSSLib" && levels[i]._parentItem.linkLib == levels[index].linkLib) {
			delLevelsItem(i);
		} else {
			i++;
		}
	}


	while (levels[index]._childItems.length != 0) {
		levels[index].removeItem(levels[index]._childItems[0]);
	}
}

/****************************************************************************************
	Appel SOAP
****************************************************************************************/

/*********************** AUTH                           *******************************/
function authSOAPParseResponse(response, args) {
	if (!response) {
		return;
	}
	var num = new Object();
	var params = response.getParameters(false, num);

	if (params[0].element.textContent != 0) {
		alert("Vous n'avez pas le droit de vous connecter");
		return false;
	}

             //   self.close();

	document.getElementById("menuitem_conn").label = "Reconnexion";
	getRSSFeedSOAP();
}

function authSOAP() {
	var params = new Array();
	
	var args = new Object();
    args.timeoutStr = "Connexion" + " user: " + glLogin + " url: " + glUrl + " port: " + glPort;

    
	params[0] = new SOAPParameter(glLogin, "login");
	params[1] = new SOAPParameter(glPassword, "password");
	dofanicall("setAuthentification", params, authSOAPParseResponse, args);
}
/*************************************************************************************/


/************** TEST ADD BOOKMARK      ***********************************************/
/***
 * Cette partie va etre virer car lors de la recuperation du bookmark... on obtient aussi les droits
 */
function testAddBookmarkResponse(response, args) {

  var num = new Object();
  var params = response.getParameters(false, num);
  var matches = params[0].value;
  var item = document.getElementById("whichFeedToAdd").selectedItem;

//item.setAttribute("access", "write");
}

/* Test Ajout Bookmark*/
function testAddBookmark(bookmark) {
	
    var params = new Array();

	var args = new Object();
    args.timeoutStr = "Test d'ajout du Bookmark: " + bookmark;

    params[0]  = new SOAPParameter(bookmark, "labelBookmark");
	
    dofanicall("testAccessAddBookmark",params,testAddBookmarkResponse, args);
}

function addmenuicon() {
   var label = document.getElementById("whichFeedToAdd").selectedItem.label;
   testAddBookmark(label);
}
/*************************************************************************************/



/*****************AJOUT DE LIEN         **********************************************/

function addLinkParseResponse(response, args) {
    if (!response) {
        return;
    }
    var num = new Object();
    var params = response.getParameters(false, num);

    var matches = params[0].element.childNodes[1].textContent;
    if (matches == -1) {
        alert("Le lien n'a pu tre insr du RSS");
    } else {
        /* recherche de l'index de l'item pere puis ajout du lien par la fonction appendItem */
        index = searchInItem("RSSLib", "linkLib", args.rss);

        var today = new Date();
	
        today.setTime(today.getTime() - (today.getTimezoneOffset() *60) * 1000);
        levels[levels.length] = new Item("RSSLink", levels[index], args.label, args.link, args.desc, today.toGMTString(),args.favicon,args.author);

        alert("Le lien a t insr avec succs au sein du RSS");
    }
}

function addLinkCall() {
    var params = new Array();
    var allFavicon = getAllTabInfo("IMAGE");

    params[0] = new SOAPParameter(document.getElementById("whichFeedToAdd").label, "labelBookmark");
    params[1] = new SOAPParameter(document.getElementById("liens-text").value, "bookmarkLink"); // l'URL du lien
    params[2] = new SOAPParameter(document.getElementById("libelle-text").value,"bookmarkLabel");
    params[3] = new SOAPParameter(document.getElementById("keyword-text").value, "bookmarkDescription"); // description du lien
    params[4] = new SOAPParameter(document.getElementById("selectRSSFeed").label, "bookmarkCategory");
    params[5] = new SOAPParameter(8, "bookmarkSiteQuality");
    params[6] = new SOAPParameter(allFavicon[document.getElementById("liens-text").selectedIndex],"bookmarkFavicon");

    var args = new Object();
    args.type  = "addLink";
    args.label = document.getElementById("libelle-text").value;
    args.link  = document.getElementById("liens-text").value;
    args.desc  = document.getElementById("keyword-text").value;
    args.rss   = document.getElementById("whichFeedToAdd").label;
    args.favicon = allFavicon[document.getElementById("liens-text").selectedIndex];
    args.author = glLogin;
    args.timeoutStr = "Ajout du lien: " + args.link;
    
    dofanicall("addOneBookmark", params, addLinkParseResponse, args);
}

/* Fonction appele au sein du XUL */
function addRSSFeed() {
	if (trim(document.getElementById("libelle-text").value) == "") {
		alert('Veuillez dfinir un libelle pour l\'URL');
		return false;
	}
 
	if (trim(document.getElementById("liens-text").value) == "") {
		alert('Veuillez dfinir l\'URL');
		return false;	
	}
	addLinkCall();
}
/*************************************************************************************/


/*************   Suppression d'un lien  **********************************************/
function delLinkParseResponse(response, args) {
    if (!response) {
        return;
    }

	index = searchInItem("RSSLink", "linkLink", args.link); 

	levels[index]._parentItem.removeItem(levels[index]);
	delLevelsItem(index);

    document.getElementById('tree-left').treeBoxObject.invalidate();
}

function removeLinkCall(link) {

    var args = new Object();
    var params = new Array();

    params[0] = new SOAPParameter(document.getElementById("selectRSSFeed").label, "labelBookmark");
    params[1] = new SOAPParameter(link, "bookmarkLink");

    args.type = "eraseLink";
    args.rss  = document.getElementById("selectRSSFeed").label;
    args.link = link;
    args.timeoutStr = "Suppression du lien: " + link;
   
    dofanicall("delOneBookmark", params, delLinkParseResponse, args);

}

/* Fonction appele au sein du XUL */
function suppRSSFeed() {
	var tree = document.getElementById("tree-left");
	var link = tree.view.getCellText(tree.currentIndex,"linkLink");
	removeLinkCall(link);
}
/*************************************************************************************/



/*********************** Demande la liste des RSS disponibles en lecture  *******/
function getRSSFeedSOAPParseResponse(response, args) {

    if (!response) {
        return;
    }
    var num = new Object();
    var params = response.getParameters(false, num);
    var second = params[0].element.getElementsByTagName("item");

    /* Ajout au sein du menulist */
    selectRSSFeed = document.getElementById("selectRSSFeedBeginElem");
    whichFeed     = document.getElementById("whichFeedToAddBeginElem");
    for (i = 0; i < second.length; i++) {
        readRSS  = document.createElement("menuitem");
        readRSS.setAttribute("label", second[i].childNodes[1].textContent);
        selectRSSFeed.appendChild(readRSS);

        if (second[i].childNodes[5].textContent == 1) {
            writeRSS = document.createElement("menuitem");
            writeRSS.setAttribute("label", second[i].childNodes[1].textContent);
            whichFeed.appendChild(writeRSS);
        }
    }
}

function getRSSFeedSOAP() {
    var params = new Array();

	var args = new Object();
    args.timeoutStr = "Rcuperation des bookmark";

    dofanicall("getBookmarks", params, getRSSFeedSOAPParseResponse, args);
}
/*************************************************************************************/


/*********************Rcuperation du RSS    ******************************************/
function getRSSFileParseResponse(response, args) {

	if (!response) {
		return;
	}

	if (args.refresh == true) {
		var index = searchInItem("RSSLib", "linkLib", args.RSSName);
		if (index != null) {
			delLevelsRSS(index, false);
		}
	}

	if (searchInItem("RSSLib", "linkLib", args.RSSName) != null && args.type == "addRSS") {
		return;
	}
//		dump(response.message.childNodes[0].textContent+ "\n") ;

	var num = new Object();
	var params = response.getParameters(false, num);
	var textContent =  params[0].element.getElementsByTagName("rssFile");
//dump("\n******************\n" + textContent[0].textContent + "\n*********************\n");

	var parser=new DOMParser();
	var resultDoc=parser.parseFromString(textContent[0].textContent,"text/xml");
	/* on lance le parsing de l'element */
  	var RSSContent = evaluateXPath(resultDoc, "//item");

	var father, libelle, link, description, pubDate, favicon, author;
	
	if (args.type == "addRSS") {
		father = levels.length;
		levels[levels.length] = new Item("RSSLib", levels[0], document.getElementById("selectRSSFeed").label, "", "","");
	} else {
		father = searchInItem("RSSLib", "linkLib", args.RSSName);
	}

	for (i = 0; i < RSSContent.length; i++) {
	   
		libelle = evaluateXPath(RSSContent[i], "./title")[0].textContent;
		link = evaluateXPath(RSSContent[i], "./link")[0].textContent;
		description = evaluateXPath(RSSContent[i], "./description")[0].textContent;
		pubDate = faniDate(evaluateXPath(RSSContent[i], "./pubDate")[0].textContent);
    try {
  		favicon = evaluateXPath(RSSContent[i], "./favicon")[0].textContent; 
    } catch(e){
    }
		author = evaluateXPath(RSSContent[i], "./author")[0].textContent;
		levels[levels.length] = new Item("RSSLink", levels[father], libelle, link, description, pubDate, favicon,author);
	}
	if (args.type == "addRSS") {
		var fct = 'refreshRSSContent("' + document.getElementById("selectRSSFeed").label + '")';
		/* 4 minutes d'interval */
		setInterval(fct, 240000);
	}
}


function getRSSFeed(toRefresh) {
	if (document.getElementById("selectRSSFeed").label == "" && toRefresh == null) {
		return;
	}	
	var params = new Array();
	if (toRefresh == null) {
		params[0]  = new SOAPParameter(document.getElementById("selectRSSFeed").label, "labelBookmark");
		toRefresh = new Object();
		toRefresh.type = "addRSS";
		toRefresh.RSSName = document.getElementById("selectRSSFeed").label;
		toRefresh.timeoutStr = "Ajout du RSS " + toRefresh.RSSName;
	} else {
		params[0]  = new SOAPParameter(toRefresh.RSSName, "labelBookmark");		
	}
	dofanicall("getRssFile", params, getRSSFileParseResponse, toRefresh);
}
/*************************************************************************************/


/****************Fonction appel lors de l'execution du timeout **********************/
function refreshRSSContent(RSSname) {
	var arg = new Object();
	arg.type = "RefreshRSS";
	arg.RSSName = RSSname;
	arg.refresh = true;
    arg.timeoutStr = "Refresh du RSS " + arg.RSSName;

	getRSSFeed(arg);
}
/*************************************************************************************/

/*Copie le lien */
function copyLink() {
    var tree = document.getElementById("tree-left");
    var link = tree.view.getCellText(tree.currentIndex,"linkLink");

    cpClipboard(link);
}

/* Affichage Informations*/
function displayInfo() {
	
	var tree = document.getElementById("tree-left");
	var link = tree.view.getCellText(tree.currentIndex,"linkLink");
	var label = tree.view.getCellText(tree.currentIndex,"linkLib");
	var keyword = tree.view.getCellText(tree.currentIndex,"linkKeywords");
	var pubDate = tree.view.getCellText(tree.currentIndex,"linkpubDate");
	var author = tree.view.getCellText(tree.currentIndex,"linkAuthor")

	alert('Libelle : ' + label + '\n Lien : ' + link + '\n Mots cls : ' + keyword + '\n Date Publication : ' + pubDate +  '\n Auteur :' + author );
}


/***
 * Cration de l'arbre
 */
function Item(type, parent, libelle, link, keyword, pubDate, favicon, author) {
  this.type = type;
  this.linkLib = libelle;
  this.linkLink = link;
  this.linkKeywords = keyword;
  this.linkpubDate = pubDate;
  this.favicon= favicon
  this.linkAuthor = author;
  this.context = "menuFlottant";
  parent.appendItem(this);
}
Item.prototype = new faniTreeView();

window.onload = function onload() {
	document.getElementById("tree-left").view = levels[0];
}
